package com.iconplus.smartproc.controller;

import com.iconplus.smartproc.entity.Jenisanggaran;
import com.iconplus.smartproc.exception.ResourceNotFoundException;
import com.iconplus.smartproc.repository.JenisanggaranRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@CrossOrigin(origins = "http://localhost:8080", allowCredentials = "true")
@RestController
@RequestMapping("/api/jenisanggaran")
public class JenisanggaranController {
        @Autowired
        private JenisanggaranRepository jenisanggaranRepository;

        //get all data
        @GetMapping
        public List<Jenisanggaran> getAllJenisanggarans(){
            return jenisanggaranRepository.findAll();
        }

        // create
        @PostMapping
        public Jenisanggaran createJenisanggaran(@RequestBody Jenisanggaran jenisanggaran) {
            return jenisanggaranRepository.save(jenisanggaran);
        }

        // get jenisanggaran by id rest api
        @GetMapping("/{id}")
        public ResponseEntity<Jenisanggaran> getJenisanggaranById(@PathVariable Long id) {
            Jenisanggaran jenisanggaran = jenisanggaranRepository.findById(id)
                    .orElseThrow(() -> new ResourceNotFoundException("Jenisanggaran not exist with id :" + id));
            return ResponseEntity.ok(jenisanggaran);
        }

        // update jenisanggaran rest api
        @PutMapping("/{id}")
        public ResponseEntity<Jenisanggaran> updateJenisanggaran(@PathVariable Long id, @RequestBody Jenisanggaran jenisanggaranDetails){
            Jenisanggaran jenisanggaran = jenisanggaranRepository.findById(id)
                    .orElseThrow(() -> new ResourceNotFoundException("Jenisanggaran not exist with id :" + id));

            jenisanggaran.setJenisanggaran(jenisanggaranDetails.getJenisanggaran());
            jenisanggaran.setKeterangan(jenisanggaranDetails.getKeterangan());

            Jenisanggaran updatedJenisanggaran =  jenisanggaranRepository.save(jenisanggaran);
            return ResponseEntity.ok(updatedJenisanggaran);
        }

        // delete jenisanggaran rest api
        @DeleteMapping("/{id}")
        public ResponseEntity<Map<String, Boolean>> deleteJenisanggaran(@PathVariable Long id){
            Jenisanggaran jenisanggaran = jenisanggaranRepository.findById(id)
                    .orElseThrow(() -> new ResourceNotFoundException("Supposmatrix not exist with id :" + id));

            jenisanggaranRepository.delete(jenisanggaran);
            Map<String, Boolean> response = new HashMap<>();
            response.put("deleted", Boolean.TRUE);
            return ResponseEntity.ok(response);
        }
}
