package com.iconplus.smartproc.controller;

import com.iconplus.smartproc.entity.Jeniskontrak;
import com.iconplus.smartproc.exception.ResourceNotFoundException;
import com.iconplus.smartproc.repository.JeniskontrakRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@CrossOrigin(origins = "http://localhost:8080", allowCredentials = "true")
@RestController
@RequestMapping("/api/jeniskontrak")
public class JeniskontrakController {
	@Autowired
	private JeniskontrakRepository jeniskontrakRepository;

	//get all data
	@GetMapping
	public List<Jeniskontrak> getAllJeniskontraks(){
		return jeniskontrakRepository.findAll();
	}

	// create
	@PostMapping
	public Jeniskontrak createJeniskontrak(@RequestBody Jeniskontrak jeniskontrak) {
		return jeniskontrakRepository.save(jeniskontrak);
	}

	// get jeniskontrak by id rest api
	@GetMapping("/{id}")
	public ResponseEntity<Jeniskontrak> getJeniskontrakById(@PathVariable Long id) {
		Jeniskontrak jeniskontrak = jeniskontrakRepository.findById(id)
				.orElseThrow(() -> new ResourceNotFoundException("Jeniskontrak not exist with id :" + id));
		return ResponseEntity.ok(jeniskontrak);
	}

	// update jeniskontrak rest api
	@PutMapping("/{id}")
	public ResponseEntity<Jeniskontrak> updateJeniskontrak(@PathVariable Long id, @RequestBody Jeniskontrak jeniskontrakDetails){
		Jeniskontrak jeniskontrak = jeniskontrakRepository.findById(id)
				.orElseThrow(() -> new ResourceNotFoundException("Jeniskontrak not exist with id :" + id));

		jeniskontrak.setJeniskontrak(jeniskontrakDetails.getJeniskontrak());
		jeniskontrak.setKeterangan(jeniskontrakDetails.getKeterangan());

		Jeniskontrak updatedJeniskontrak = jeniskontrakRepository.save(jeniskontrak);
		return ResponseEntity.ok(updatedJeniskontrak);
	}

	// delete jeniskontrak rest api
	@DeleteMapping("/{id}")
	public ResponseEntity<Map<String, Boolean>> deleteJeniskontrak(@PathVariable Long id){
		Jeniskontrak jeniskontrak = jeniskontrakRepository.findById(id)
				.orElseThrow(() -> new ResourceNotFoundException("Jeniskontrak not exist with id :" + id));

		jeniskontrakRepository.delete(jeniskontrak);
		Map<String, Boolean> response = new HashMap<>();
		response.put("deleted", Boolean.TRUE);
		return ResponseEntity.ok(response);
	}
}