package com.iconplus.smartproc.controller;

import com.iconplus.smartproc.entity.Jenispengadaan;
import com.iconplus.smartproc.exception.ResourceNotFoundException;
import com.iconplus.smartproc.repository.JenispengadaanRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@CrossOrigin(origins = "http://localhost:8080", allowCredentials = "true")
@RestController
@RequestMapping("/api/jenispengadaan")
public class JenispengadaanController {
        @Autowired
        private JenispengadaanRepository jenispengadaanRepository;

        //get all data
        @GetMapping
        public List<Jenispengadaan> getAllJenispengadaans(){
            return jenispengadaanRepository.findAll();
        }

        // create
        @PostMapping
        public Jenispengadaan createJenispengadaan(@RequestBody Jenispengadaan jenispengadaan) {
            return jenispengadaanRepository.save(jenispengadaan);
        }

        // get jenispengadaan by id rest api
        @GetMapping("/{id}")
        public ResponseEntity<Jenispengadaan> getJenispengadaanById(@PathVariable Long id) {
            Jenispengadaan jenispengadaan = jenispengadaanRepository.findById(id)
                    .orElseThrow(() -> new ResourceNotFoundException("Jenispengadaan not exist with id :" + id));
            return ResponseEntity.ok(jenispengadaan);
        }

        // update jenispengadaan rest api
        @PutMapping("/{id}")
        public ResponseEntity<Jenispengadaan> updateJenispengadaan(@PathVariable Long id, @RequestBody Jenispengadaan jenispengadaanDetails){
            Jenispengadaan jenispengadaan = jenispengadaanRepository.findById(id)
                    .orElseThrow(() -> new ResourceNotFoundException("Jenispengadaan not exist with id :" + id));

            jenispengadaan.setJenispengadaan(jenispengadaanDetails.getJenispengadaan());
            jenispengadaan.setKeterangan(jenispengadaanDetails.getKeterangan());

            Jenispengadaan updatedJenispengadaan =  jenispengadaanRepository.save(jenispengadaan);
            return ResponseEntity.ok(updatedJenispengadaan);
        }

        // delete jenispengadaan rest api
        @DeleteMapping("/{id}")
        public ResponseEntity<Map<String, Boolean>> deleteJenispengadaan(@PathVariable Long id){
            Jenispengadaan jenispengadaan = jenispengadaanRepository.findById(id)
                    .orElseThrow(() -> new ResourceNotFoundException("Supposmatrix not exist with id :" + id));

            jenispengadaanRepository.delete(jenispengadaan);
            Map<String, Boolean> response = new HashMap<>();
            response.put("deleted", Boolean.TRUE);
            return ResponseEntity.ok(response);
        }
}
