package com.iconplus.smartproc.controller;

import com.iconplus.smartproc.entity.Metodepengadaan;
import com.iconplus.smartproc.exception.ResourceNotFoundException;
import com.iconplus.smartproc.repository.MetodepengadaanRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@CrossOrigin(origins = "http://localhost:8080", allowCredentials = "true")
@RestController
@RequestMapping("/api/metodepengadaan")
public class MetodepengadaanController {
	@Autowired
	private MetodepengadaanRepository metodepengadaanRepository;

	//get all data
	@GetMapping
	public List<Metodepengadaan> getAllMetodepengadaans(){
		return metodepengadaanRepository.findAll();
	}

	// create
	@PostMapping
	public Metodepengadaan createMetodepengadaan(@RequestBody Metodepengadaan metodepengadaan) {
		return metodepengadaanRepository.save(metodepengadaan);
	}

	// get metodepengadaan by id rest api
	@GetMapping("/{id}")
	public ResponseEntity<Metodepengadaan> getMetodepengadaanById(@PathVariable Long id) {
		Metodepengadaan metodepengadaan = metodepengadaanRepository.findById(id)
				.orElseThrow(() -> new ResourceNotFoundException("Metodepengadaan not exist with id :" + id));
		return ResponseEntity.ok(metodepengadaan);
	}

	// update metodepengadaan rest api
	@PutMapping("/{id}")
	public ResponseEntity<Metodepengadaan> updateMetodepengadaan(@PathVariable Long id, @RequestBody Metodepengadaan metodepengadaanDetails){
		Metodepengadaan metodepengadaan = metodepengadaanRepository.findById(id)
				.orElseThrow(() -> new ResourceNotFoundException("Metodepengadaan not exist with id :" + id));

		metodepengadaan.setMetodepengadaan(metodepengadaanDetails.getMetodepengadaan());
		metodepengadaan.setKeterangan(metodepengadaanDetails.getKeterangan());

		Metodepengadaan updatedMetodepengadaan = metodepengadaanRepository.save(metodepengadaan);
		return ResponseEntity.ok(updatedMetodepengadaan);
	}

	// delete metodepengadaan rest api
	@DeleteMapping("/{id}")
	public ResponseEntity<Map<String, Boolean>> deleteMetodepengadaan(@PathVariable Long id){
		Metodepengadaan metodepengadaan = metodepengadaanRepository.findById(id)
				.orElseThrow(() -> new ResourceNotFoundException("Metodepengadaan not exist with id :" + id));

		metodepengadaanRepository.delete(metodepengadaan);
		Map<String, Boolean> response = new HashMap<>();
		response.put("deleted", Boolean.TRUE);
		return ResponseEntity.ok(response);
	}
}



