package com.iconplus.smartproc.controller;

import com.iconplus.smartproc.entity.Metodepenyampaian;
import com.iconplus.smartproc.exception.ResourceNotFoundException;
import com.iconplus.smartproc.repository.MetodepenyampaianRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@CrossOrigin(origins = "http://localhost:8080", allowCredentials = "true")
@RestController
@RequestMapping("/api/metodepenyampaian")
public class MetodepenyampaianController {
	@Autowired
	private MetodepenyampaianRepository metodepenyampaianRepository;

	//get all data
	@GetMapping
	public List<Metodepenyampaian> getAllMetodepenyampaians(){
		return metodepenyampaianRepository.findAll();
	}

	// create
	@PostMapping
	public Metodepenyampaian createMetodepenyampaian(@RequestBody Metodepenyampaian metodepenyampaian) {
		return metodepenyampaianRepository.save(metodepenyampaian);
	}

	// get metodepenyampaian by id rest api
	@GetMapping("/{id}")
	public ResponseEntity<Metodepenyampaian> getMetodepenyampaianById(@PathVariable Long id) {
		Metodepenyampaian metodepenyampaian = metodepenyampaianRepository.findById(id)
				.orElseThrow(() -> new ResourceNotFoundException("Metodepenyampaian not exist with id :" + id));
		return ResponseEntity.ok(metodepenyampaian);
	}

	// update metodepenyampaian rest api
	@PutMapping("/{id}")
	public ResponseEntity<Metodepenyampaian> updateMetodepenyampaian(@PathVariable Long id, @RequestBody Metodepenyampaian metodepenyampaianDetails){
		Metodepenyampaian metodepenyampaian = metodepenyampaianRepository.findById(id)
				.orElseThrow(() -> new ResourceNotFoundException("Metodepenyampaian not exist with id :" + id));

		metodepenyampaian.setMetodepenyampaian(metodepenyampaianDetails.getMetodepenyampaian());
		metodepenyampaian.setKeterangan(metodepenyampaianDetails.getKeterangan());

		Metodepenyampaian updatedMetodepenyampaian = metodepenyampaianRepository.save(metodepenyampaian);
		return ResponseEntity.ok(updatedMetodepenyampaian);
	}

	// delete metodepenyampaian rest api
	@DeleteMapping("/{id}")
	public ResponseEntity<Map<String, Boolean>> deleteMetodepenyampaian(@PathVariable Long id){
		Metodepenyampaian metodepenyampaian = metodepenyampaianRepository.findById(id)
				.orElseThrow(() -> new ResourceNotFoundException("Metodepenyampaian not exist with id :" + id));

		metodepenyampaianRepository.delete(metodepenyampaian);
		Map<String, Boolean> response = new HashMap<>();
		response.put("deleted", Boolean.TRUE);
		return ResponseEntity.ok(response);
	}
}



