package com.iconplus.smartproc.controller;

import com.iconplus.smartproc.entity.Strategipengadaan;
import com.iconplus.smartproc.exception.ResourceNotFoundException;
import com.iconplus.smartproc.repository.StrategipengadaanRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@CrossOrigin(origins = "http://localhost:8080", allowCredentials = "true")
@RestController
@RequestMapping("/api/strategipengadaan")
public class StrategipengadaanController {
        @Autowired
        private StrategipengadaanRepository strategipengadaanRepository;

        //get all data
        @GetMapping
        public List<Strategipengadaan> getAllstrategipengadaans(){
            return strategipengadaanRepository.findAll();
        }

        // create
        @PostMapping
        public Strategipengadaan createStrategipengadaan(@RequestBody Strategipengadaan strategipengadaan) {
            return strategipengadaanRepository.save(strategipengadaan);
        }

        // get strategipengadaan by id rest api
        @GetMapping("/{id}")
        public ResponseEntity<Strategipengadaan> getStrategipengadaanById(@PathVariable Long id) {
            Strategipengadaan strategipengadaan = strategipengadaanRepository.findById(id)
                    .orElseThrow(() -> new ResourceNotFoundException("Strategipengadaan not exist with id :" + id));
            return ResponseEntity.ok(strategipengadaan);
        }

        // update strategipengadaan rest api
        @PutMapping("/{id}")
        public ResponseEntity<Strategipengadaan> updateStrategipengadaan(@PathVariable Long id, @RequestBody Strategipengadaan strategipengadaanDetails){
            Strategipengadaan strategipengadaan = strategipengadaanRepository.findById(id)
                    .orElseThrow(() -> new ResourceNotFoundException("Strategipengadaan not exist with id :" + id));

            strategipengadaan.setStrategipengadaan(strategipengadaanDetails.getStrategipengadaan());
            strategipengadaan.setKeterangan(strategipengadaanDetails.getKeterangan());

            Strategipengadaan updatedStrategipengadaan =  strategipengadaanRepository.save(strategipengadaan);
            return ResponseEntity.ok(updatedStrategipengadaan);
        }

        // delete strategipengadaan rest api
        @DeleteMapping("/{id}")
        public ResponseEntity<Map<String, Boolean>> deleteStrategipengadaan(@PathVariable Long id){
            Strategipengadaan strategipengadaan = strategipengadaanRepository.findById(id)
                    .orElseThrow(() -> new ResourceNotFoundException("Strategipengadaan not exist with id :" + id));

            strategipengadaanRepository.delete(strategipengadaan);
            Map<String, Boolean> response = new HashMap<>();
            response.put("deleted", Boolean.TRUE);
            return ResponseEntity.ok(response);
        }




}
