package com.iconplus.smartproc.controller;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.iconplus.smartproc.exception.ResourceNotFoundException;
import com.iconplus.smartproc.entity.Supplypositioningmatrix;
import com.iconplus.smartproc.repository.SupplypositioningmatrixRepository;

@CrossOrigin(origins = "http://localhost:8080", allowCredentials = "true")
@RestController
@RequestMapping("/api/supplypositioningmatrix")
public class SupplypositioningmatrixController {
    @Autowired
    private SupplypositioningmatrixRepository supplypositioningmatrixRepository;

    //get all data
    @GetMapping
    public List<Supplypositioningmatrix> getAllSupplypositioningmatrix(){
        return supplypositioningmatrixRepository.findAll();
    }

    // create
    @PostMapping
    public Supplypositioningmatrix createSupplypositioningmatrix(@RequestBody Supplypositioningmatrix supplypositioningmatrix) {
        return supplypositioningmatrixRepository.save(supplypositioningmatrix);
    }

    // get supplypositioningmatrix by id rest api
    @GetMapping("/{id}")
    public ResponseEntity<Supplypositioningmatrix> getSupplypositioningmatrixById(@PathVariable Long id) {
        Supplypositioningmatrix supplypositioningmatrix = supplypositioningmatrixRepository.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("Supplypositioningmatrix not exist with id :" + id));
        return ResponseEntity.ok(supplypositioningmatrix);
    }

    // update jenispengadaan rest api
    @PutMapping("/{id}")
    public ResponseEntity<Supplypositioningmatrix> updateSupplypositioningmatrix(@PathVariable Long id, @RequestBody Supplypositioningmatrix supplypositioningmatrixDetails){
        Supplypositioningmatrix supplypositioningmatrix = supplypositioningmatrixRepository.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("Supplypositioningmatrix not exist with id :" + id));

        supplypositioningmatrix.setSupplypositioningmatrix(supplypositioningmatrixDetails.getSupplypositioningmatrix());
        supplypositioningmatrix.setKeterangan(supplypositioningmatrixDetails.getKeterangan());

        Supplypositioningmatrix updatedSupplypositioningmatrix = supplypositioningmatrixRepository.save(supplypositioningmatrix);
        return ResponseEntity.ok(updatedSupplypositioningmatrix);
    }

    // delete jenispengadaan rest api
    @DeleteMapping("/{id}")
    public ResponseEntity<Map<String, Boolean>> deleteSupplypositioningmatrix(@PathVariable Long id){
        Supplypositioningmatrix supplypositioningmatrix = supplypositioningmatrixRepository.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("Unit inisiator not exist with id :" + id));

        supplypositioningmatrixRepository.delete(supplypositioningmatrix);
        Map<String, Boolean> response = new HashMap<>();
        response.put("deleted", Boolean.TRUE);
        return ResponseEntity.ok(response);
    }
}
