package com.iconplus.smartproc.controller;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.iconplus.smartproc.exception.ResourceNotFoundException;
import com.iconplus.smartproc.entity.Unitinisiator;
import com.iconplus.smartproc.repository.UnitinisiatorRepository;

@CrossOrigin(origins = "http://localhost:8080", allowCredentials = "true")
@RestController
@RequestMapping("/api/unitinisiator")
public class UnitinisiatorController {
    @Autowired
    private UnitinisiatorRepository unitinisiatorRepository;

    //get all data
    @GetMapping
    public List<Unitinisiator> getAllUnitinisiator(){
        return unitinisiatorRepository.findAll();
    }

    // create
    @PostMapping
    public Unitinisiator createUnitinisiator(@RequestBody Unitinisiator unitinisiator) {
        return unitinisiatorRepository.save(unitinisiator);
    }

    // get unitinisiator by id rest api
    @GetMapping("/{id}")
    public ResponseEntity<Unitinisiator> getUnitinisiatorById(@PathVariable Long id) {
        Unitinisiator unitinisiator = unitinisiatorRepository.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("Unitinisiator not exist with id :" + id));
        return ResponseEntity.ok(unitinisiator);
    }

    // update jenispengadaan rest api
    @PutMapping("/{id}")
    public ResponseEntity<Unitinisiator> updateUnitinisiator(@PathVariable Long id, @RequestBody Unitinisiator unitinisiatorDetails){
        Unitinisiator unitinisiator = unitinisiatorRepository.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("Unitinisiator not exist with id :" + id));

        unitinisiator.setUnitinisiator(unitinisiatorDetails.getUnitinisiator());
        unitinisiator.setKeterangan(unitinisiatorDetails.getKeterangan());

        Unitinisiator updatedUnitinisiator = unitinisiatorRepository.save(unitinisiator);
        return ResponseEntity.ok(updatedUnitinisiator);
    }

    // delete jenispengadaan rest api
    @DeleteMapping("/{id}")
    public ResponseEntity<Map<String, Boolean>> deleteUnitinisiator(@PathVariable Long id){
        Unitinisiator unitinisiator = unitinisiatorRepository.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("Unit inisiator not exist with id :" + id));

        unitinisiatorRepository.delete(unitinisiator);
        Map<String, Boolean> response = new HashMap<>();
        response.put("deleted", Boolean.TRUE);
        return ResponseEntity.ok(response);
    }
}
